Index: trunk/tests/AuthFileTest.php
===================================================================
--- trunk/tests/AuthFileTest.php	(revision 12)
+++ 	(revision )
@@ -1,100 +1,0 @@
-<?php
-/**
- * PHPUnit test case for Auth_File
- * 
- * The method skeletons below need to be filled in with 
- * real data so that the tests will run correctly. Replace 
- * all EXPECTED_VAL and PARAM strings with real data. 
- * 
- * Created with PHPUnit_Skeleton on 2005-08-09
- */
-require_once 'PHPUnit.php';
-class Auth_FileTest extends PHPUnit_TestCase {
-
-    var $Auth_File;
-
-    function Auth_FileTest($name)
-    {
-        $this->PHPUnit_TestCase($name);
-    }
-
-    function setUp()
-    {
-        require dirname(__FILE__) . '/_config.inc.php';
-        require_once '../lib/Auth_File.inc.php';
-        $this->Auth_File =& new Auth_File(array('htpasswd_file' => dirname(__FILE__) . '/_test_htpasswd'));
-    }
-
-    function tearDown()
-    {
-        unset($this->Auth_File);
-    }
-
-    function test_authenticate()
-    {
-        $true = $this->Auth_File->authenticate('testuser', 'testpass');
-        $this->assertTrue($true, 'testuser not authorized with good password.');
-
-        $false = $this->Auth_File->authenticate('testuser', 'wrongpass');
-        $this->assertFalse($false, 'testuser not blocked with bad password.');
-    }
-
-    function test_login()
-    {
-        $result = $this->Auth_File->login('testuser', 'testpass');
-        $this->assertTrue($result, 'testuser login failed.');
-        $this->assertTrue($_SESSION['_auth']['authenticated'], 'testuser authentication not found in session.');
-    }
-
-    function test_clearauth()
-    {
-        $result = $this->Auth_File->login('testuser', 'testpass');
-        $this->Auth_File->clearauth();
-        $this->assertFalse($_SESSION['_auth']['authenticated'], 'testuser authentication not false in session.');
-    }
-
-    function test_isloggedin()
-    {
-        $this->Auth_File->login('testuser', 'testpass');
-        $true = $this->Auth_File->isloggedin();
-        $this->assertTrue($true, 'testuser not logged in but should be.');
-
-        $this->Auth_File->clearauth();
-        $false = $this->Auth_File->isloggedin();
-        $this->assertFalse($false, 'testuser is logged in but shouldn\'t be.');
-    }
-
-//     function test_isadmin()
-//     {
-//         $this->Auth_File->login('testuser', 'testpass');
-//         $true = $this->Auth_File->isadmin();
-//         $this->assertTrue($true);
-//     }
-// 
-//     function test_requireadminlogin()
-//     {
-//         $result = $this->Auth_File->requireadminlogin(PARAM);
-//         $expected = EXPECTED_VAL;
-//         $this->assertEquals($expected, $result);
-//     }
-// 
-//     function test__encrypt()
-//     {
-//         $result = $this->Auth_File->_encrypt(PARAM);
-//         $expected = EXPECTED_VAL;
-//         $this->assertEquals($expected, $result);
-//     }
-// 
-//     function test__salt()
-//     {
-//         $result = $this->Auth_File->_salt(PARAM);
-//         $expected = EXPECTED_VAL;
-//         $this->assertEquals($expected, $result);
-//     }
-
-}
-// Running the test.
-$suite = new PHPUnit_TestSuite('Auth_FileTest');
-$result = PHPUnit::run($suite);
-echo $result->toString();
-?>
Index: trunk/tests/AuthSQLTest.php
===================================================================
--- trunk/tests/AuthSQLTest.php	(revision 12)
+++ 	(revision )
@@ -1,223 +1,0 @@
-<?php
-/**
- * PHPUnit test case for Auth_SQL
- * 
- * The method skeletons below need to be filled in with 
- * real data so that the tests will run correctly. Replace 
- * all EXPECTED_VAL and PARAM strings with real data. 
- * 
- * Created with PHPUnit_Skeleton on 2005-08-09
- */
-require_once 'PHPUnit.php';
-class Auth_SQLTest extends PHPUnit_TestCase {
-
-    var $Auth_SQL;
-
-    function Auth_SQLTest($name)
-    {
-        $this->PHPUnit_TestCase($name);
-    }
-
-    function setUp()
-    {
-        require dirname(__FILE__) . '/_config.inc.php';
-        require_once '../lib/Auth_SQL.inc.php';
-        $this->Auth_SQL =& new Auth_SQL('testauth');
-        $this->Auth_SQL->setParam(array(
-            'db_table'          => 'test_user_tbl',
-            'db_primary_key'    => 'user_id',
-            'db_login_table'    => 'test_login_tbl',
-            'login_url'         => '/login.php',
-            'blocking'          => true
-        ));
-
-        // Use fresh user table.
-        $this->Auth_SQL->initDB(true);
-
-        // Insert test data.
-        DB::query("
-            INSERT INTO test_user_tbl (
-                username,
-                userpass,
-                first_name,
-                last_name,
-                email,
-                user_type
-            ) VALUES (
-                'testuser',
-                md5('testpass'),
-                'John',
-                'Doe',
-                'root@localhost',
-                'admin'
-            )
-        ");
-        
-    }
-
-    function tearDown()
-    {
-        unset($this->Auth_SQL);
-        DB::query("DROP TABLE IF EXISTS test_user_tbl");
-        DB::query("DROP TABLE IF EXISTS test_login_tbl");
-    }
-
-    function test_setval()
-    {
-        $this->Auth_SQL->setval('testuserkey', 'testuserval');
-        $this->assertEquals('testuserval', $_SESSION[$this->Auth_SQL->_sess]['user_data']['testuserkey']);
-    }
-
-    function test_getval()
-    {
-        $_SESSION[$this->Auth_SQL->_sess]['user_data']['testuserkey'] = 'testuserval';
-        $val = $this->Auth_SQL->getVal('testuserkey');
-        $this->assertEquals('testuserval', $val);
-    }
-
-    function test_setparam()
-    {
-        $this->Auth_SQL->setParam(array(
-            'login_url'         => 'testloginurl.php'
-        ));
-        $this->assertEquals('testloginurl.php', $this->Auth_SQL->_params['login_url']);
-    }
-
-    function test_getparam()
-    {
-        $this->Auth_SQL->_params['login_url'] = 'testloginurl.php';
-        $param = $this->Auth_SQL->getParam('login_url');
-        $this->assertEquals('testloginurl.php', $param);
-    }
-
-    function test_clearauth()
-    {
-        $login = $this->Auth_SQL->login('testuser', 'testpass');
-        $this->assertTrue($login, 'User login failed, but should have succeeded.');
-        $before_logged_in = $this->Auth_SQL->isloggedin();
-        $this->assertTrue($before_logged_in, 'User is not logged in, but should be.');
-        $this->Auth_SQL->clearauth();
-        $after_logged_in = $this->Auth_SQL->isloggedin();
-        $this->assertFalse($after_logged_in, 'User is still logged in but should not be.');
-    }
-
-    function test_authenticate()
-    {
-        $true = $this->Auth_SQL->authenticate('testuser', 'testpass');
-        $this->assertTrue($true, 'User login failed, but should have succeeded.');
-        $false = $this->Auth_SQL->authenticate('testuser', 'wrongpass');
-        $this->assertfalse($false, 'User login succeeded, but should have failed.');
-    }
-
-    function test_login_and_isLoggedIn()
-    {
-        $login = $this->Auth_SQL->login('testuser', 'testpass');
-        $this->assertTrue($login, '1. User login failed, but should have succeeded.');
-        $before_logged_in = $this->Auth_SQL->isloggedin();
-        $this->assertTrue($before_logged_in, '2. User is not logged in, but should be.');
-        $this->Auth_SQL->clearauth();
-        $after_logged_in = $this->Auth_SQL->isloggedin();
-        $this->assertFalse($after_logged_in, '3. User is still logged in but should not be.');
-
-        $login2 = $this->Auth_SQL->login('testuser', 'wrongpass');
-        $this->assertFalse($login2, '4. User login succeeded, but should have failed.');
-        $before_logged_in2 = $this->Auth_SQL->isloggedin();
-        $this->assertFalse($before_logged_in2, '5. User is logged in, but should not be.');
-        $this->Auth_SQL->clearauth();
-        $after_logged_in2 = $this->Auth_SQL->isloggedin();
-        $this->assertFalse($after_logged_in2, '6. Wrong user is still logged in but should not be.');
-    }
-
-    function test_requirelogin()
-    {
-//         $this->Auth_SQL->requirelogin('Login is required!');
-    }
-
-    function test_blockaccount()
-    {
-        $this->Auth_SQL->login('testuser', 'testpass');
-        $this->Auth_SQL->blockaccount(null, 'blocktestuser');
-        $qid = DB::query("
-            SELECT blocked_reason
-            FROM test_user_tbl
-        ");
-        list($reason) = mysql_fetch_row($qid);
-        $this->assertEquals('blocktestuser', $reason, "Block not found in DB record.");
-    }
-
-    function test_unblockaccount()
-    {
-        DB::query("
-            UPDATE test_user_tbl SET blocked_reason = 'blocktestuser'
-        ");
-        $this->Auth_SQL->unblockaccount();
-
-        $qid = DB::query("
-            SELECT blocked_reason
-            FROM test_user_tbl
-        ");
-        list($reason) = mysql_fetch_row($qid);
-        $this->assertTrue('' == $reason, "Block not removed from DB record.");
-    }
-
-    function test_usernameexists()
-    {
-        $result = $this->Auth_SQL->usernameexists('testuser');
-        $this->assertTrue($result);
-    }
-
-    function test_getusername()
-    {
-        $result = $this->Auth_SQL->getusername(1);
-        $this->assertEquals('testuser', $result);
-    }
-
-    function test_generatepassword()
-    {
-        $result = $this->Auth_SQL->generatepassword('xCVcvd');
-        $this->assertRegExp('/[bcdfghjklmnprstvwxzBCDFGHJKLMNPRSTVWXZaeiouyAEIOUY0123456789][bcdfghjklmnprstvwxzBCDFGHJKLMNPRSTVWXZ][aeiouyAEIOUY][bcdfghjklmnprstvwxz][aeiouy][0123456789]/', $result, 'Generated password does not match intended pattern');
-    }
-
-    function test_encryptpassword()
-    {
-        $result = $this->Auth_SQL->encryptpassword('123');
-        $this->assertEquals('202cb962ac59075b964b07152d234b70', $result);
-    }
-
-    function test_setpassword()
-    {
-        $this->Auth_SQL->setpassword(null, '123');
-        $qid = DB::query("
-            SELECT userpass
-            FROM test_user_tbl
-        ");
-        list($pass) = mysql_fetch_row($qid);
-        $this->assertEquals('202cb962ac59075b964b07152d234b70', $pass);
-    }
-
-    function test_resetpassword()
-    {
-        $result = $this->Auth_SQL->resetpassword(1, 'Because this is a test.');
-        $this->assertType('array', $result);
-    }
-
-//     function test_inclearancezone()
-//     {
-//         $result = $this->Auth_SQL->inclearancezone(PARAM);
-//         $expected = EXPECTED_VAL;
-//         $this->assertEquals($expected, $result);
-//     }
-// 
-//     function test_requireaccessclearance()
-//     {
-//         $result = $this->Auth_SQL->requireaccessclearance(PARAM);
-//         $expected = EXPECTED_VAL;
-//         $this->assertEquals($expected, $result);
-//     }
-
-}
-// Running the test.
-$suite = new PHPUnit_TestSuite('Auth_SQLTest');
-$result = PHPUnit::run($suite);
-echo $result->toString();
-?>
Index: trunk/tests/Auth_FileTest.php
===================================================================
--- trunk/tests/Auth_FileTest.php	(revision 13)
+++ trunk/tests/Auth_FileTest.php	(revision 13)
@@ -0,0 +1,100 @@
+<?php
+/**
+ * PHPUnit test case for Auth_File
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class Auth_FileTest extends PHPUnit_TestCase {
+
+    var $Auth_File;
+
+    function Auth_FileTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/Auth_File.inc.php';
+        $this->Auth_File =& new Auth_File(array('htpasswd_file' => dirname(__FILE__) . '/_test_htpasswd'));
+    }
+
+    function tearDown()
+    {
+        unset($this->Auth_File);
+    }
+
+    function test_authenticate()
+    {
+        $true = $this->Auth_File->authenticate('testuser', 'testpass');
+        $this->assertTrue($true, 'testuser not authorized with good password.');
+
+        $false = $this->Auth_File->authenticate('testuser', 'wrongpass');
+        $this->assertFalse($false, 'testuser not blocked with bad password.');
+    }
+
+    function test_login()
+    {
+        $result = $this->Auth_File->login('testuser', 'testpass');
+        $this->assertTrue($result, 'testuser login failed.');
+        $this->assertTrue($_SESSION['_auth']['authenticated'], 'testuser authentication not found in session.');
+    }
+
+    function test_clearauth()
+    {
+        $result = $this->Auth_File->login('testuser', 'testpass');
+        $this->Auth_File->clearauth();
+        $this->assertFalse($_SESSION['_auth']['authenticated'], 'testuser authentication not false in session.');
+    }
+
+    function test_isloggedin()
+    {
+        $this->Auth_File->login('testuser', 'testpass');
+        $true = $this->Auth_File->isloggedin();
+        $this->assertTrue($true, 'testuser not logged in but should be.');
+
+        $this->Auth_File->clearauth();
+        $false = $this->Auth_File->isloggedin();
+        $this->assertFalse($false, 'testuser is logged in but shouldn\'t be.');
+    }
+
+//     function test_isadmin()
+//     {
+//         $this->Auth_File->login('testuser', 'testpass');
+//         $true = $this->Auth_File->isadmin();
+//         $this->assertTrue($true);
+//     }
+// 
+//     function test_requireadminlogin()
+//     {
+//         $result = $this->Auth_File->requireadminlogin(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+// 
+//     function test__encrypt()
+//     {
+//         $result = $this->Auth_File->_encrypt(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+// 
+//     function test__salt()
+//     {
+//         $result = $this->Auth_File->_salt(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('Auth_FileTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/Auth_SQLTest.php
===================================================================
--- trunk/tests/Auth_SQLTest.php	(revision 13)
+++ trunk/tests/Auth_SQLTest.php	(revision 13)
@@ -0,0 +1,223 @@
+<?php
+/**
+ * PHPUnit test case for Auth_SQL
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class Auth_SQLTest extends PHPUnit_TestCase {
+
+    var $Auth_SQL;
+
+    function Auth_SQLTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/Auth_SQL.inc.php';
+        $this->Auth_SQL =& new Auth_SQL('testauth');
+        $this->Auth_SQL->setParam(array(
+            'db_table'          => 'test_user_tbl',
+            'db_primary_key'    => 'user_id',
+            'db_login_table'    => 'test_login_tbl',
+            'login_url'         => '/login.php',
+            'blocking'          => true
+        ));
+
+        // Use fresh user table.
+        $this->Auth_SQL->initDB(true);
+
+        // Insert test data.
+        DB::query("
+            INSERT INTO test_user_tbl (
+                username,
+                userpass,
+                first_name,
+                last_name,
+                email,
+                user_type
+            ) VALUES (
+                'testuser',
+                md5('testpass'),
+                'John',
+                'Doe',
+                'root@localhost',
+                'admin'
+            )
+        ");
+        
+    }
+
+    function tearDown()
+    {
+        unset($this->Auth_SQL);
+        DB::query("DROP TABLE IF EXISTS test_user_tbl");
+        DB::query("DROP TABLE IF EXISTS test_login_tbl");
+    }
+
+    function test_setval()
+    {
+        $this->Auth_SQL->setval('testuserkey', 'testuserval');
+        $this->assertEquals('testuserval', $_SESSION[$this->Auth_SQL->_sess]['user_data']['testuserkey']);
+    }
+
+    function test_getval()
+    {
+        $_SESSION[$this->Auth_SQL->_sess]['user_data']['testuserkey'] = 'testuserval';
+        $val = $this->Auth_SQL->getVal('testuserkey');
+        $this->assertEquals('testuserval', $val);
+    }
+
+    function test_setparam()
+    {
+        $this->Auth_SQL->setParam(array(
+            'login_url'         => 'testloginurl.php'
+        ));
+        $this->assertEquals('testloginurl.php', $this->Auth_SQL->_params['login_url']);
+    }
+
+    function test_getparam()
+    {
+        $this->Auth_SQL->_params['login_url'] = 'testloginurl.php';
+        $param = $this->Auth_SQL->getParam('login_url');
+        $this->assertEquals('testloginurl.php', $param);
+    }
+
+    function test_clearauth()
+    {
+        $login = $this->Auth_SQL->login('testuser', 'testpass');
+        $this->assertTrue($login, 'User login failed, but should have succeeded.');
+        $before_logged_in = $this->Auth_SQL->isloggedin();
+        $this->assertTrue($before_logged_in, 'User is not logged in, but should be.');
+        $this->Auth_SQL->clearauth();
+        $after_logged_in = $this->Auth_SQL->isloggedin();
+        $this->assertFalse($after_logged_in, 'User is still logged in but should not be.');
+    }
+
+    function test_authenticate()
+    {
+        $true = $this->Auth_SQL->authenticate('testuser', 'testpass');
+        $this->assertTrue($true, 'User login failed, but should have succeeded.');
+        $false = $this->Auth_SQL->authenticate('testuser', 'wrongpass');
+        $this->assertfalse($false, 'User login succeeded, but should have failed.');
+    }
+
+    function test_login_and_isLoggedIn()
+    {
+        $login = $this->Auth_SQL->login('testuser', 'testpass');
+        $this->assertTrue($login, '1. User login failed, but should have succeeded.');
+        $before_logged_in = $this->Auth_SQL->isloggedin();
+        $this->assertTrue($before_logged_in, '2. User is not logged in, but should be.');
+        $this->Auth_SQL->clearauth();
+        $after_logged_in = $this->Auth_SQL->isloggedin();
+        $this->assertFalse($after_logged_in, '3. User is still logged in but should not be.');
+
+        $login2 = $this->Auth_SQL->login('testuser', 'wrongpass');
+        $this->assertFalse($login2, '4. User login succeeded, but should have failed.');
+        $before_logged_in2 = $this->Auth_SQL->isloggedin();
+        $this->assertFalse($before_logged_in2, '5. User is logged in, but should not be.');
+        $this->Auth_SQL->clearauth();
+        $after_logged_in2 = $this->Auth_SQL->isloggedin();
+        $this->assertFalse($after_logged_in2, '6. Wrong user is still logged in but should not be.');
+    }
+
+    function test_requirelogin()
+    {
+//         $this->Auth_SQL->requirelogin('Login is required!');
+    }
+
+    function test_blockaccount()
+    {
+        $this->Auth_SQL->login('testuser', 'testpass');
+        $this->Auth_SQL->blockaccount(null, 'blocktestuser');
+        $qid = DB::query("
+            SELECT blocked_reason
+            FROM test_user_tbl
+        ");
+        list($reason) = mysql_fetch_row($qid);
+        $this->assertEquals('blocktestuser', $reason, "Block not found in DB record.");
+    }
+
+    function test_unblockaccount()
+    {
+        DB::query("
+            UPDATE test_user_tbl SET blocked_reason = 'blocktestuser'
+        ");
+        $this->Auth_SQL->unblockaccount();
+
+        $qid = DB::query("
+            SELECT blocked_reason
+            FROM test_user_tbl
+        ");
+        list($reason) = mysql_fetch_row($qid);
+        $this->assertTrue('' == $reason, "Block not removed from DB record.");
+    }
+
+    function test_usernameexists()
+    {
+        $result = $this->Auth_SQL->usernameexists('testuser');
+        $this->assertTrue($result);
+    }
+
+    function test_getusername()
+    {
+        $result = $this->Auth_SQL->getusername(1);
+        $this->assertEquals('testuser', $result);
+    }
+
+    function test_generatepassword()
+    {
+        $result = $this->Auth_SQL->generatepassword('xCVcvd');
+        $this->assertRegExp('/[bcdfghjklmnprstvwxzBCDFGHJKLMNPRSTVWXZaeiouyAEIOUY0123456789][bcdfghjklmnprstvwxzBCDFGHJKLMNPRSTVWXZ][aeiouyAEIOUY][bcdfghjklmnprstvwxz][aeiouy][0123456789]/', $result, 'Generated password does not match intended pattern');
+    }
+
+    function test_encryptpassword()
+    {
+        $result = $this->Auth_SQL->encryptpassword('123');
+        $this->assertEquals('202cb962ac59075b964b07152d234b70', $result);
+    }
+
+    function test_setpassword()
+    {
+        $this->Auth_SQL->setpassword(null, '123');
+        $qid = DB::query("
+            SELECT userpass
+            FROM test_user_tbl
+        ");
+        list($pass) = mysql_fetch_row($qid);
+        $this->assertEquals('202cb962ac59075b964b07152d234b70', $pass);
+    }
+
+    function test_resetpassword()
+    {
+        $result = $this->Auth_SQL->resetpassword(1, 'Because this is a test.');
+        $this->assertType('array', $result);
+    }
+
+//     function test_inclearancezone()
+//     {
+//         $result = $this->Auth_SQL->inclearancezone(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+// 
+//     function test_requireaccessclearance()
+//     {
+//         $result = $this->Auth_SQL->requireaccessclearance(PARAM);
+//         $expected = EXPECTED_VAL;
+//         $this->assertEquals($expected, $result);
+//     }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('Auth_SQLTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/GoogleAPITest.php
===================================================================
--- trunk/tests/GoogleAPITest.php	(revision 12)
+++ 	(revision )
@@ -1,76 +1,0 @@
-<?php
-/// FIXME: Tests not implemented.
-return;
-
-/**
- * PHPUnit test case for GoogleAPI
- * 
- * The method skeletons below need to be filled in with 
- * real data so that the tests will run correctly. Replace 
- * all EXPECTED_VAL and PARAM strings with real data. 
- * 
- * Created with PHPUnit_Skeleton on 2005-08-09
- */
-require_once 'PHPUnit.php';
-class GoogleAPITest extends PHPUnit_TestCase {
-
-    var $GoogleAPI;
-
-    function GoogleAPITest($name)
-    {
-        $this->PHPUnit_TestCase($name);
-    }
-
-    function setUp()
-    {
-        require dirname(__FILE__) . '/_config.inc.php';
-        require_once '../lib/GoogleAPI.inc.php';
-        $this->GoogleAPI =& new GoogleAPI(PARAM);
-    }
-
-    function tearDown()
-    {
-        unset($this->GoogleAPI);
-    }
-
-    function test_getcachedpage()
-    {
-        $result = $this->GoogleAPI->getcachedpage(PARAM);
-        $expected = EXPECTED_VAL;
-        $this->assertEquals($expected, $result);
-    }
-
-    function test_getspellingsuggestion()
-    {
-        $result = $this->GoogleAPI->getspellingsuggestion(PARAM);
-        $expected = EXPECTED_VAL;
-        $this->assertEquals($expected, $result);
-    }
-
-    function test_search()
-    {
-        $result = $this->GoogleAPI->search(PARAM);
-        $expected = EXPECTED_VAL;
-        $this->assertEquals($expected, $result);
-    }
-
-    function test__performapicall()
-    {
-        $result = $this->GoogleAPI->_performapicall(PARAM);
-        $expected = EXPECTED_VAL;
-        $this->assertEquals($expected, $result);
-    }
-
-    function test_getfault()
-    {
-        $result = $this->GoogleAPI->getfault(PARAM);
-        $expected = EXPECTED_VAL;
-        $this->assertEquals($expected, $result);
-    }
-
-}
-// Running the test.
-$suite = new PHPUnit_TestSuite('GoogleAPITest');
-$result = PHPUnit::run($suite);
-echo $result->toString();
-?>
Index: trunk/tests/Google_APITest.php
===================================================================
--- trunk/tests/Google_APITest.php	(revision 13)
+++ trunk/tests/Google_APITest.php	(revision 13)
@@ -0,0 +1,76 @@
+<?php
+/// FIXME: Tests not implemented.
+return;
+
+/**
+ * PHPUnit test case for GoogleAPI
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class GoogleAPITest extends PHPUnit_TestCase {
+
+    var $GoogleAPI;
+
+    function GoogleAPITest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/GoogleAPI.inc.php';
+        $this->GoogleAPI =& new GoogleAPI(PARAM);
+    }
+
+    function tearDown()
+    {
+        unset($this->GoogleAPI);
+    }
+
+    function test_getcachedpage()
+    {
+        $result = $this->GoogleAPI->getcachedpage(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getspellingsuggestion()
+    {
+        $result = $this->GoogleAPI->getspellingsuggestion(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_search()
+    {
+        $result = $this->GoogleAPI->search(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test__performapicall()
+    {
+        $result = $this->GoogleAPI->_performapicall(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getfault()
+    {
+        $result = $this->GoogleAPI->getfault(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('GoogleAPITest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>