Index: /trunk/bin/module_maker/skel/adm_list.ihtml
===================================================================
--- /trunk/bin/module_maker/skel/adm_list.ihtml	(revision 20)
+++ /trunk/bin/module_maker/skel/adm_list.ihtml	(revision 21)
@@ -12,5 +12,5 @@
         <?php // printSelectForm('<##>_tbl', "CONCAT(<##>_id, '&mdash;', city, '&mdash;', title)", '<##>_id', getFormData('filter_<##>'), array('Any <##>'), 'ORDER BY <##> ASC'); ?>
     </select>
-    <input type="submit" name="list" value="<?php echo _("Search"); ?>" />
+    <input type="submit" value="<?php echo _("Search"); ?>" />
 </div>
 </form>
Index: /trunk/bin/module_maker/skel/admin.php
===================================================================
--- /trunk/bin/module_maker/skel/admin.php	(revision 20)
+++ /trunk/bin/module_maker/skel/admin.php	(revision 21)
@@ -216,5 +216,5 @@
     if (!$frm = mysql_fetch_assoc($qid)) {
         App::logMsg('Could not find record with %PRIMARY_KEY%: ' . $id, LOG_WARNING, __FILE__, __LINE__);
-        App::raiseMsg(sprintf(_("The requested record %s could not be found"), $id), MSG_ERR, __FILE__, __LINE__);
+        App::raiseMsg(sprintf(_("The requested record %s could not be found."), $id), MSG_ERR, __FILE__, __LINE__);
         App::dieBoomerangURL();
     }
@@ -244,28 +244,28 @@
     if ($lock->isLocked() && !$lock->isMine()) {
         $lock->dieErrorPage();
-    } else {
-        // Break the cache because we are changing the list data.
-        SessionCache::breakCache($_SERVER['PHP_SELF']);
-        
-        // Get the information for this object.
-        $qid = DB::query("
-            SELECT <##> 
-            FROM %DB_TBL%
-            WHERE %PRIMARY_KEY% = '" . addslashes($id) . "'
-        ");
-        if (! list($name) = mysql_fetch_row($qid)) {
-            App::logMsg('Could not find record with %PRIMARY_KEY%: ' . $id, LOG_WARNING, __FILE__, __LINE__);
-            App::raiseMsg(sprintf(_("The requested record %s could not be found"), $id), MSG_ERR, __FILE__, __LINE__);
-            App::dieBoomerangURL();
-        }
-        
-        // Delete the record.
-        DB::query("DELETE FROM %DB_TBL% WHERE %PRIMARY_KEY% = '" . addslashes($id) . "'");
-        
-        App::raiseMsg(sprintf(_("The %ITEM_TITLE% <strong>%s</strong> has been deleted."), $name), MSG_SUCCESS, __FILE__, __LINE__);
-
-        // Unlock record.
-        $lock->remove();
-    }
+    }
+
+    // Break the cache because we are changing the list data.
+    SessionCache::breakCache($_SERVER['PHP_SELF']);
+    
+    // Get the information for this object.
+    $qid = DB::query("
+        SELECT <##> 
+        FROM %DB_TBL%
+        WHERE %PRIMARY_KEY% = '" . addslashes($id) . "'
+    ");
+    if (! list($name) = mysql_fetch_row($qid)) {
+        App::logMsg('Could not find record with %PRIMARY_KEY%: ' . $id, LOG_WARNING, __FILE__, __LINE__);
+        App::raiseMsg(sprintf(_("The requested record %s could not be found."), $id), MSG_ERR, __FILE__, __LINE__);
+        App::dieBoomerangURL();
+    }
+    
+    // Delete the record.
+    DB::query("DELETE FROM %DB_TBL% WHERE %PRIMARY_KEY% = '" . addslashes($id) . "'");
+    
+    App::raiseMsg(sprintf(_("The %ITEM_TITLE% <strong>%s</strong> has been deleted."), $name), MSG_SUCCESS, __FILE__, __LINE__);
+
+    // Unlock record.
+    $lock->remove();
 }
 
@@ -297,19 +297,19 @@
     if ($lock->isLocked() && !$lock->isMine()) {
         $lock->dieErrorPage();
-    } else {
-        // Break the cache because we are changing the list data.
-        SessionCache::breakCache($_SERVER['PHP_SELF']);
+    }
+
+    // Break the cache because we are changing the list data.
+    SessionCache::breakCache($_SERVER['PHP_SELF']);
 
 %UPDATE%
-        
-        // Create version.
-        $version = RecordVersion::getInstance($GLOBALS['auth']);
-        $version->create('%DB_TBL%', '%PRIMARY_KEY%', $frm['%PRIMARY_KEY%'], $frm['<##>']);
-    
-        App::raiseMsg(sprintf(_("The %ITEM_TITLE% <strong>%s</strong> has been updated."), $frm['<##>']), MSG_SUCCESS, __FILE__, __LINE__);
-
-        // Unlock record.
-        $lock->remove();
-    }
+    
+    // Create version.
+    $version = RecordVersion::getInstance($GLOBALS['auth']);
+    $version->create('%DB_TBL%', '%PRIMARY_KEY%', $frm['%PRIMARY_KEY%'], $frm['<##>']);
+
+    App::raiseMsg(sprintf(_("The %ITEM_TITLE% <strong>%s</strong> has been updated."), $frm['<##>']), MSG_SUCCESS, __FILE__, __LINE__);
+
+    // Unlock record.
+    $lock->remove();
 }
 
Index: /trunk/bin/module_maker/sql.cli.php
===================================================================
--- /trunk/bin/module_maker/sql.cli.php	(revision 20)
+++ /trunk/bin/module_maker/sql.cli.php	(revision 21)
@@ -127,13 +127,13 @@
         continue;
     }
-    $key_eq_val .= $comma . "\n                $k = $v";
+    $key_eq_val .= $comma . "\n            $k = $v";
     $comma = ',';
 }
 echo <<<E_O_F
-        // Update record data.
-        DB::query("
-            UPDATE $db_tbl SET$key_eq_val
-            WHERE $primary_key = '" . addslashes(\$frm['$primary_key']) . "'
-        ");
+    // Update record data.
+    DB::query("
+        UPDATE $db_tbl SET$key_eq_val
+        WHERE $primary_key = '" . addslashes(\$frm['$primary_key']) . "'
+    ");
 E_O_F;
 }
Index: /trunk/css/admin.inc.css
===================================================================
--- /trunk/css/admin.inc.css	(revision 20)
+++ /trunk/css/admin.inc.css	(revision 21)
@@ -115,5 +115,5 @@
     float: left;
     width: 9em;
-    margin: 0;
+    margin: 0 0 10px 0;
     border-right: 1px solid gray;
     padding: 0;
@@ -142,4 +142,12 @@
     text-decoration: none;
     padding: 1px;
+}
+
+#leftnav #navlist li.label
+{
+    color: #999;
+	padding-top: 10px;
+	font-size: 75%;
+	font-weight: bold;
 }
 
Index: /trunk/css/utilities.inc.css
===================================================================
--- /trunk/css/utilities.inc.css	(revision 20)
+++ /trunk/css/utilities.inc.css	(revision 21)
@@ -41,5 +41,5 @@
 input.tiny, textarea.tiny
 {
-	width: 5em;
+	width: 4.75em;
 }
 
Index: unk/docs/codebase_script_template.php
===================================================================
--- /trunk/docs/codebase_script_template.php	(revision 20)
+++ 	(revision )
@@ -1,41 +1,0 @@
-<?php
-/**
- * <##>
- * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information.
- * @author  Quinn Comendant <quinn@strangecode.com>
- * @version 1.0
- * @since   <##>
- */
-
-require_once dirname(__FILE__) . '/_config.inc.php';
-
-$auth->requireLogin();
-App::sslOn();
-
-require_once 'codebase/lib/FormValidator.inc.php';
-
-
-/******************************************************************************
- * CONFIG
- *****************************************************************************/
-
-
-
-/******************************************************************************
- * MAIN
- *****************************************************************************/
-
-
-
-/******************************************************************************
- * OUTPUT
- *****************************************************************************/
-
-
-
-/******************************************************************************
- * FUNCTIONS
- *****************************************************************************/
-
-
-?>
Index: /trunk/docs/example_script_template.php
===================================================================
--- /trunk/docs/example_script_template.php	(revision 21)
+++ /trunk/docs/example_script_template.php	(revision 21)
@@ -0,0 +1,41 @@
+<?php
+/**
+ * <##>
+ * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information.
+ * @author  Quinn Comendant <quinn@strangecode.com>
+ * @version 1.0
+ * @since   <##>
+ */
+
+require_once dirname(__FILE__) . '/_config.inc.php';
+
+$auth->requireLogin();
+App::sslOn();
+
+require_once 'codebase/lib/FormValidator.inc.php';
+
+
+/******************************************************************************
+ * CONFIG
+ *****************************************************************************/
+
+
+
+/******************************************************************************
+ * MAIN
+ *****************************************************************************/
+
+
+
+/******************************************************************************
+ * OUTPUT
+ *****************************************************************************/
+
+
+
+/******************************************************************************
+ * FUNCTIONS
+ *****************************************************************************/
+
+
+?>
Index: /trunk/docs/revision_history.txt
===================================================================
--- /trunk/docs/revision_history.txt	(revision 20)
+++ /trunk/docs/revision_history.txt	(revision 21)
@@ -23,4 +23,5 @@
     - RecordVersion
     - SessionCache
+    - Upload
 
 One application will always have distinct:
@@ -53,5 +54,8 @@
     - do not need to be set in any specific order
     - missing vars are dynamically accounted for.
-      
+
+Auth_SQL object:
+    - Modified to set the auth-type within the object. We needed to use one object name ($auth) for all instances so we can use template that use this variable name commonly. login.php, lock.php, versions.php, password.php -- all in the codebase services will be used globally on multiple sites and need this variable name set.
+
 DB object:
     - Self contained class for DB functions. db::query is the only necessary function. Maintains connections and state independent of App.
Index: /trunk/lib/SessionCache.inc.php
===================================================================
--- /trunk/lib/SessionCache.inc.php	(revision 20)
+++ /trunk/lib/SessionCache.inc.php	(revision 21)
@@ -13,4 +13,5 @@
 {
     var $_params = array(
+        'enabled' => true,
         'soft_limit' => 204800,
         'hard_limit' => 4194304,
@@ -43,4 +44,8 @@
     function setParam($params)
     {
+        if (!isset($this) || !is_a($this, 'SessionCache')) {
+            $this =& SessionCache::getInstance();
+        }
+
         if (isset($params) && is_array($params)) {
             // Merge new parameters with old overriding only those passed.
@@ -60,4 +65,8 @@
     function getParam($param)
     {
+        if (!isset($this) || !is_a($this, 'SessionCache')) {
+            $this =& SessionCache::getInstance();
+        }
+
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
@@ -86,5 +95,11 @@
     function putCache($var, $var_id, $force_it_in=false)
     {
-        $cache =& SessionCache::getInstance();
+        if (!isset($this) || !is_a($this, 'SessionCache')) {
+            $this =& SessionCache::getInstance();
+        }
+
+        if (!$this->getParam('enabled')) {
+            return false;
+        }
 
         $var_id = md5($var_id);
@@ -92,11 +107,11 @@
         $serialized_var_len = strlen($serialized_var);
         
-        if ($serialized_var_len >= $cache->getParam('soft_limit') && !$force_it_in) {
-            App::logMsg(sprintf('Serialized variable (%s bytes) more than soft_limit (%s bytes).', $serialized_var_len, $cache->getParam('soft_limit')), LOG_NOTICE, __FILE__, __LINE__);
-            return false;
-        }
-        
-        if ($serialized_var_len >= $cache->getParam('hard_limit')) {
-            App::logMsg(sprintf('Serialized variable (%s bytes) more than hard_limit (%s bytes).', $serialized_var_len, $cache->getParam('hard_limit')), LOG_NOTICE, __FILE__, __LINE__);
+        if ($serialized_var_len >= $this->getParam('soft_limit') && !$force_it_in) {
+            App::logMsg(sprintf('Serialized variable (%s bytes) more than soft_limit (%s bytes).', $serialized_var_len, $this->getParam('soft_limit')), LOG_NOTICE, __FILE__, __LINE__);
+            return false;
+        }
+        
+        if ($serialized_var_len >= $this->getParam('hard_limit')) {
+            App::logMsg(sprintf('Serialized variable (%s bytes) more than hard_limit (%s bytes).', $serialized_var_len, $this->getParam('hard_limit')), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -107,6 +122,6 @@
             unset($_SESSION['_session_cache'][$var_id]);
             // Continue to prune the cache if it's length is too long for the new variable to fit, but keep at least MIN_ITEMS at least.
-            while (strlen(serialize($_SESSION['_session_cache'])) + $serialized_var_len >= $cache->getParam('soft_limit') 
-            && sizeof($_SESSION['_session_cache']) >= $cache->getParam('min_items')) {
+            while (strlen(serialize($_SESSION['_session_cache'])) + $serialized_var_len >= $this->getParam('soft_limit') 
+            && sizeof($_SESSION['_session_cache']) >= $this->getParam('min_items')) {
                 array_shift($_SESSION['_session_cache']);
             }
@@ -133,4 +148,12 @@
     function getCache($var_id)
     {
+        if (!isset($this) || !is_a($this, 'SessionCache')) {
+            $this =& SessionCache::getInstance();
+        }
+
+        if (!$this->getParam('enabled')) {
+            return false;
+        }
+        
         $var_id = md5($var_id);
         if (isset($_SESSION['_session_cache'][$var_id])) {
@@ -155,4 +178,12 @@
     function isCached($var_id)
     {
+        if (!isset($this) || !is_a($this, 'SessionCache')) {
+            $this =& SessionCache::getInstance();
+        }
+
+        if (!$this->getParam('enabled')) {
+            return false;
+        }
+
         $var_id = md5($var_id);
         return isset($_SESSION['_session_cache'][$var_id]);
Index: /trunk/lib/TemplateGlue.inc.php
===================================================================
--- /trunk/lib/TemplateGlue.inc.php	(revision 20)
+++ /trunk/lib/TemplateGlue.inc.php	(revision 21)
@@ -72,4 +72,5 @@
         return $enum[1];
     } else {
+        App::logMsg(sprintf('No set or enum fields found.', null), LOG_DEBUG, __FILE__, __LINE__);
         return false;
     }
@@ -87,5 +88,5 @@
     $values = getSetEnumFieldValues($db_table, $db_col);
     if ($values === false) {
-        ?><option value=""><?php echo _("n/a"); ?></option>
+        ?><option value="">&nbsp;</option>
         <?php
         return false;
Index: /trunk/services/admins.php
===================================================================
--- /trunk/services/admins.php	(revision 20)
+++ /trunk/services/admins.php	(revision 21)
@@ -196,5 +196,4 @@
     }
 
-    // If the username was changed during edit, verify.
     if (getFormData('user_type') == 'root' && 'root' != $auth->getVal('user_type')) {
         $fv->addError('user_type', sprintf(_("You do not have clearance to create a user with root privileges."), null));
@@ -267,5 +266,5 @@
     if (!$frm = mysql_fetch_assoc($qid)) {
         App::logMsg('Could not find record with admin_id: ' . $id, LOG_WARNING, __FILE__, __LINE__);
-        App::raiseMsg(sprintf(_("The requested record %s could not be found"), $id), MSG_ERR, __FILE__, __LINE__);
+        App::raiseMsg(sprintf(_("The requested record %s could not be found."), $id), MSG_ERR, __FILE__, __LINE__);
         App::dieBoomerangURL();
     }
@@ -312,40 +311,40 @@
     if ($lock->isLocked() && !$lock->isMine()) {
         $lock->dieErrorPage();
+    }
+
+    // Break the cache because we are changing the list data.
+    SessionCache::breakCache($_SERVER['PHP_SELF']);
+    
+    // Get the information for this object.
+    $qid = DB::query("
+        SELECT username, user_type from admin_tbl
+        WHERE admin_id = '" . addslashes($id) . "'
+    ");
+    if (! list($name, $user_type) = mysql_fetch_row($qid)) {
+        App::logMsg('Could not find record with admin_id: ' . $id, LOG_WARNING, __FILE__, __LINE__);
+        App::raiseMsg(sprintf(_("The requested record %s could not be found."), $id), MSG_ERR, __FILE__, __LINE__);
+        App::dieBoomerangURL();
+    }
+    
+    // Get the information for this object.
+    $qid = DB::query("SELECT COUNT(*) from admin_tbl");
+    list($num_admins) = mysql_fetch_row($qid);
+    if ('root' == $user_type && 'root' != $auth->getVal('user_type')) {
+        // Only root users can delete root users!
+        App::raiseMsg(_("You do not have clearance to delete a root administrator."), MSG_NOTICE, __FILE__, __LINE__);
+    } else if ($num_admins <= 1) {
+        // There must always be at least one admnistrator!
+        App::raiseMsg(_("You cannot delete the only administrator in the database. There must be at least one to log in and create other users."), MSG_NOTICE, __FILE__, __LINE__);
+    } else if ($auth->getVal('user_id') == $id) {
+        // Do not delete yourself!
+        App::raiseMsg(_("You cannot delete yourself."), MSG_NOTICE, __FILE__, __LINE__);
     } else {
-        // Break the cache because we are changing the list data.
-        SessionCache::breakCache($_SERVER['PHP_SELF']);
-        
-        // Get the information for this object.
-        $qid = DB::query("
-            SELECT username, user_type from admin_tbl
-            WHERE admin_id = '" . addslashes($id) . "'
-        ");
-        if (! list($name, $user_type) = mysql_fetch_row($qid)) {
-            App::logMsg('Could not find record with admin_id: ' . $id, LOG_WARNING, __FILE__, __LINE__);
-            App::raiseMsg(sprintf(_("The requested record %s could not be found"), $id), MSG_ERR, __FILE__, __LINE__);
-            App::dieBoomerangURL();
-        }
-        
-        // Get the information for this object.
-        $qid = DB::query("SELECT COUNT(*) from admin_tbl");
-        list($num_admins) = mysql_fetch_row($qid);
-        if ('root' == $user_type && 'root' != $auth->getVal('user_type')) {
-            // Only root users can delete root users!
-            App::raiseMsg(_("You do not have clearance to delete a root administrator."), MSG_NOTICE, __FILE__, __LINE__);
-        } else if ($num_admins <= 1) {
-            // There must always be at least one admnistrator!
-            App::raiseMsg(_("You cannot delete the only administrator in the database. There must be at least one to log in and create other users."), MSG_NOTICE, __FILE__, __LINE__);
-        } else if ($auth->getVal('user_id') == $id) {
-            // Do not delete yourself!
-            App::raiseMsg(_("You cannot delete yourself."), MSG_NOTICE, __FILE__, __LINE__);
-        } else {
-            // Delete the record.
-            DB::query("DELETE FROM admin_tbl WHERE admin_id = '" . addslashes($id) . "'");
-            App::raiseMsg(sprintf(_("The admin <strong>%s</strong> has been deleted."), $name), MSG_SUCCESS, __FILE__, __LINE__);
-        }
-
-        // Unlock record.
-        $lock->remove();
-    }
+        // Delete the record.
+        DB::query("DELETE FROM admin_tbl WHERE admin_id = '" . addslashes($id) . "'");
+        App::raiseMsg(sprintf(_("The admin <strong>%s</strong> has been deleted."), $name), MSG_SUCCESS, __FILE__, __LINE__);
+    }
+
+    // Unlock record.
+    $lock->remove();
 }
 
@@ -399,36 +398,36 @@
     if ($lock->isLocked() && !$lock->isMine()) {
         $lock->dieErrorPage();
-    } else {
-        // Break the cache because we are changing the list data.
-        SessionCache::breakCache($_SERVER['PHP_SELF']);
-        
-        // If the userpass is left blank or with the filler **** characters, we don't want to update it.
-        if (!empty($frm['userpass']) && !preg_match('/[\*]{4,}/', $frm['userpass'])) {
-            // Set user password.
-            $auth->setPassword($frm['admin_id'], $frm['userpass']);
-        }
-        
-        // Update record data.
-        DB::query("
-            UPDATE admin_tbl SET
-                username = '" . addslashes($frm['username']) . "',
-                first_name = '" . addslashes($frm['first_name']) . "',
-                last_name = '" . addslashes($frm['last_name']) . "',
-                email = '" . addslashes($frm['email']) . "',
-                user_type = '" . addslashes($frm['user_type']) . "',
-                modified_by_user_id = '" . addslashes($auth->getVal('user_id')) . "',
-                modified_datetime = NOW()
-            WHERE admin_id = '" . addslashes($frm['admin_id']) . "'
-        ");
-
-        // Create version.
-        $version = RecordVersion::getInstance($GLOBALS['auth']);
-        $version->create('admin_tbl', 'admin_id', $frm['admin_id'], $frm['username']);
-    
-        App::raiseMsg(sprintf(_("The Admin <strong>%s</strong> has been updated."), $frm['username']), MSG_SUCCESS, __FILE__, __LINE__);
-
-        // Unlock record.
-        $lock->remove();
-    }
+    }
+
+    // Break the cache because we are changing the list data.
+    SessionCache::breakCache($_SERVER['PHP_SELF']);
+    
+    // If the userpass is left blank or with the filler **** characters, we don't want to update it.
+    if (!empty($frm['userpass']) && !preg_match('/[\*]{4,}/', $frm['userpass'])) {
+        // Set user password.
+        $auth->setPassword($frm['admin_id'], $frm['userpass']);
+    }
+    
+    // Update record data.
+    DB::query("
+        UPDATE admin_tbl SET
+            username = '" . addslashes($frm['username']) . "',
+            first_name = '" . addslashes($frm['first_name']) . "',
+            last_name = '" . addslashes($frm['last_name']) . "',
+            email = '" . addslashes($frm['email']) . "',
+            user_type = '" . addslashes($frm['user_type']) . "',
+            modified_by_user_id = '" . addslashes($auth->getVal('user_id')) . "',
+            modified_datetime = NOW()
+        WHERE admin_id = '" . addslashes($frm['admin_id']) . "'
+    ");
+
+    // Create version.
+    $version = RecordVersion::getInstance($GLOBALS['auth']);
+    $version->create('admin_tbl', 'admin_id', $frm['admin_id'], $frm['username']);
+
+    App::raiseMsg(sprintf(_("The Admin <strong>%s</strong> has been updated."), $frm['username']), MSG_SUCCESS, __FILE__, __LINE__);
+
+    // Unlock record.
+    $lock->remove();
 }
 
Index: /trunk/services/templates/admin_list.ihtml
===================================================================
--- /trunk/services/templates/admin_list.ihtml	(revision 20)
+++ /trunk/services/templates/admin_list.ihtml	(revision 21)
@@ -8,5 +8,5 @@
     
     <input type="text" class="small" size="20" name="search_query" value="<?php echo getFormData('search_query'); ?>" title="<?php echo oTxt(_("Fields searched: Admin id, Username, Userpass, First name, Last name, Email, User type, Login abuse exempt, Blocked, Blocked reason, Abuse warning level, Seconds online, Last login datetime, Last access datetime, Last login ip, Added by user id, Modified by user id, Added datetime, Modified datetime.")); ?>" />
-    <input type="submit" name="list" value="<?php echo _("Search"); ?>" />
+    <input type="submit" value="<?php echo _("Search"); ?>" />
 </div>
 
Index: /trunk/services/versions.php
===================================================================
--- /trunk/services/versions.php	(revision 20)
+++ /trunk/services/versions.php	(revision 21)
@@ -79,14 +79,14 @@
     if ($lock->isLocked() && !$lock->isMine()) {
         $lock->dieErrorPage();
+    }
+
+    if ($v = $version->restore($version_id)) {
+        // Create version of this restored record as the "current" version.
+        $version->create($record_table, $record_key, $record_val, $v['version_title']);
+        App::raiseMsg(sprintf(_("The record <strong>%s</strong> has been replaced with <strong>%s</strong> version <strong>%s</strong> from <strong>%s</strong>."), getFormData('version_title'), $v['version_title'], $version_id, $v['version_datetime']), MSG_SUCCESS, __FILE__, __LINE__);
+        App::dieBoomerangURL('versions', array('break_list_cache'=>'true', false));
     } else {
-        if ($v = $version->restore($version_id)) {
-            // Create version of this restored record as the "current" version.
-            $version->create($record_table, $record_key, $record_val, $v['version_title']);
-            App::raiseMsg(sprintf(_("The record <strong>%s</strong> has been replaced with <strong>%s</strong> version <strong>%s</strong> from <strong>%s</strong>."), getFormData('version_title'), $v['version_title'], $version_id, $v['version_datetime']), MSG_SUCCESS, __FILE__, __LINE__);
-            App::dieBoomerangURL('versions', array('break_list_cache'=>'true', false));
-        } else {
-            App::raiseMsg(_("Version restoration failed."), MSG_ERR, __FILE__, __LINE__);
-            App::dieURL($_SERVER['PHP_SELF']);
-        }
+        App::raiseMsg(_("Version restoration failed."), MSG_ERR, __FILE__, __LINE__);
+        App::dieURL($_SERVER['PHP_SELF']);
     }
     break;